/*
	NXColorPanel.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "Panel.h"
#import "View.h"

#define NX_GRAYMODE            0
#define NX_RGBMODE             1
#define NX_CMYKMODE            2
#define NX_HSBMODE             3
#define NX_CUSTOMPALETTEMODE   4
#define NX_COLORLISTMODE       5
#define NX_WHEELMODE           6

#define NX_GRAYMODEMASK           0x0001
#define NX_RGBMODEMASK            0x0002
#define NX_CMYKMODEMASK           0x0004
#define NX_HSBMODEMASK            0x0008
#define NX_CUSTOMPALETTEMODEMASK  0x0010
#define NX_COLORLISTMODEMASK      0x0020
#define NX_WHEELMODEMASK          0x0040

#define NX_ALLMODESMASK \
    (NX_GRAYMODEMASK|\
    NX_RGBMODEMASK| \
    NX_CMYKMODEMASK| \
    NX_HSBMODEMASK| \
    NX_CUSTOMPALETTEMODEMASK| \
    NX_COLORLISTMODEMASK| \
    NX_WHEELMODEMASK)
    
    
// These are for the CustomPickers provided by the system.  These are the
// values these pickers return in response to:"insertionOrder" message.
// Your picker should have insertion numbers greater than, equal to, or
// in between these, to determine your buttons insertion position in the
// ColorPanel.
#define NX_WHEEL_INSERTION           (0.50)
#define NX_SLIDERS_INSERTION         (0.51)
#define NX_CUSTOMPALETTE_INSERTION   (0.52)
#define NX_LIST_INSERTION            (0.53)



@interface NXColorPanel : Panel
{
    void *              _cpPrivate;
    int                 _reservedCPint[15];
}

+ (BOOL)dragColor:(NXColor)color withEvent:(NXEvent *)theEvent fromView:sourceView;

+ sharedInstance:(BOOL)create;
+ (void)setPickerMask:(int)mask;
+ (void)setPickerMode:(int)mode;

+ allocFromZone:(NXZone *)zone;
+ alloc;

- setAccessoryView:aView;
- accessoryView;
- setContinuous:(BOOL)flag;
- (BOOL)isContinuous;
- setShowAlpha:(BOOL)flag;
- (BOOL)doesShowAlpha;
- updateCustomColorList;
- setMode:(int)mode;
- (int)mode;
- setColor:(NXColor)color;
- (NXColor)color;
- (float)alpha;
- setAction:(SEL)aSelector;
- setTarget:anObject;
- attachColorList:colorList;
- detachColorList:colorList;
- read:(NXTypedStream *)stream;

@end

@interface View(ColorAcceptor)
/*
 * Obsolete API: The drag/drop API, in conjunction with the Pasteboard
 * (NXColorPboardType) should be used instead of this method.
 */
- acceptColor:(NXColor)color atPoint:(const NXPoint *)aPoint;

@end
